#!/bin/sh

#
# ACTION FILE: located in /lib/udev/
#

err() {
                echo "$@" >&2
                if [ -x /bin/logger ]; then
                        /bin/logger -t "${0##*/}[$$]" "$@"
                fi
}

DRV_NAME=qlcnic
SYSFS=/sys
ETH=${FW_DUMP}
QFWD=${SYSFS}/class/net/${ETH}/device/fw_dump
DFILE_PATH=/opt/QLogic_Corporation/FW_Dumps
DFILE=${DFILE_PATH}/${DRV_NAME}_fw_dump_${ETH}_`eval date +%Y%m%d_%H%M%S`.txt

mkdir -p $DFILE_PATH &> /dev/null
# Verify fw_dump binary-attribute file
if ! test -f ${QFWD} ; then
        err "qlcnic: no firmware dump file at interface $ETH!!!"
        exit 1
fi

# Go with dump
rm -f $DFILE
size=`cat /sys/class/net/${ETH}/device/fwdump_size`
(( remainder = size%4096 ))
(( loops = size/4096 ))
if [ $remainder != "0" ]; then
(( loops++ ))
fi
for (( i = 0; i < $loops ; i++ ))
do
    echo "Page: $i"
    cat /sys/class/net/${ETH}/device/fw_dump >> $DFILE
done

if ! test -s "${DFILE}" ; then
                err "qlcnic: no firmware dump file at interface ${ETH}!!!"
                rm ${DFILE}
                exit 1
fi

gzip ${DFILE}
err "qlcnic: firmware dump saved to file ${DFILE}.gz."
exit 0
